index = ctf_fs_ds_file_build_index(ds_file, ds_file_info);
if (!index) {
- BT_COMP_LOGW("Failed to index CTF stream file \'%s\'",
+ BT_COMP_OR_COMP_CLASS_LOGE_APPEND_CAUSE(
+ self_comp, self_comp_class,
+ "Failed to index CTF stream file \'%s\'",
ds_file->file->path->str);
+ goto error;
}
if (begin_ns == -1) {
struct ctf_fs_trace *ctf_fs_trace;
/*
- * Owned by this. May be NULL.
- *
- * A stream cannot be assumed to be indexed as the indexing might have
- * been skipped. Moreover, the index's fields may not all be available
- * depending on the producer (e.g. timestamp_begin/end are not
- * mandatory).
+ * Owned by this.
*/
struct ctf_fs_ds_index *index;
};
--- /dev/null
+#!/bin/bash
+#
+# Copyright (C) 2019 EfficiOS Inc.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; only version 2
+# of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+# This test validates that a `src.ctf.fs` component handles gracefully invalid
+# CTF traces and produces the expected error message.
+
+SH_TAP=1
+
+if [ "x${BT_TESTS_SRCDIR:-}" != "x" ]; then
+ UTILSSH="$BT_TESTS_SRCDIR/utils/utils.sh"
+else
+ UTILSSH="$(dirname "$0")/../../../utils/utils.sh"
+fi
+
+# shellcheck source=../../../utils/utils.sh
+source "$UTILSSH"
+
+fail_trace_dir="$BT_CTF_TRACES_PATH/fail"
+
+stdout_file=$(mktemp -t test_ctf_fail_stdout.XXXXXX)
+stderr_file=$(mktemp -t test_ctf_fail_stderr.XXXXXX)
+
+test_fail() {
+ local name="$1"
+ local expected_error_msg="$2"
+
+ bt_cli "${stdout_file}" "${stderr_file}" \
+ "${fail_trace_dir}/${name}"
+ isnt $? 0 "Trace ${name}: babeltrace exits with an error"
+
+ grep --silent "${expected_error_msg}" "${stderr_file}"
+ ok $? "Trace ${name}: babeltrace produces the expected error message"
+}
+
+
+plan_tests 2
+
+test_fail "invalid-packet-size/trace" "Failed to index CTF stream file '.*channel0_3'"
+
+rm -f "${stdout_file}" "${stderr_file}"